/**************************************************************************
** Filename: COM.h
**
** Title: Series 5000 Eyetracker Software
**
** Description:
** This is the header file for COM.cpp.
**
***************************************************************************
**
** Modification History:
**    1.0,  01/31/99, THC, Initial version.
**
**************************************************************************/

#ifndef __COM_H
#define __COM_H

#include <vcl\vcl.h>
#pragma hdrstop

class TCOM: public TComponent{
private:
  HANDLE  hCom;
  AnsiString  FCOM;
  int     FBaudRate;
  bool    FOpened;
  void  __fastcall SetBaudRate( int rate );
  void  __fastcall SetCOM( AnsiString aCOM );
public:
  __fastcall TCOM(TComponent* Owner);
  __fastcall ~TCOM();
  bool __fastcall initialize( AnsiString aCOM,  int rate );
  void __fastcall close();
  void __fastcall reset();
  void __fastcall flush_input();
  void __fastcall flush_output();
  int  __fastcall get_input_count();
  int  __fastcall get_output_space();
  Byte __fastcall read_byte();
  bool __fastcall write_byte( const Byte& data );
  bool __fastcall read_buffer( Byte *data, int count, DWORD *actualSize);
  bool __fastcall write_buffer (Byte *buffer, int count, DWORD *actualWrite );
  __property int BaudRate = { read = FBaudRate, write = SetBaudRate };
  __property bool Opened = { read = FOpened };
  __property AnsiString COM = { read = FCOM, write = SetCOM };
};

class EComError : public EInOutError{};

#endif

